float sine(float dimension, float amplitude, float frequency, float phase) {
    return amplitude * sin(frequency + (dimension + phase));
}

float leaves(vec3 l, vec3 bp, float t) {
    if(l.g>l.b||l.g>l.r||l.b>l.r) {
        return sine(bp.x*1.2 + bp.z*0.7, 0.05, t * 0.5, 0.0) + sine(bp.x*0.5 + bp.z*0.9, 0.08, t * 0.3, 2.4);
    } else {
        return 0.0;
    }
}

float water(vec3 bp, float t) {
    return sine(bp.x * 0.0 + bp.z * 0.0, 0.0, t * 0.0, 0.0) + sine(bp.x * 0.0 + bp.z * 0.0, 0.0, t * 0.0, 0.0);
}